% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
% EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
% MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
% IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
% OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
% ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
% OTHER DEALINGS IN THE SOFTWARE.
%
% The authors and OFCOM (CH) do not provide any support for this Software
%
% Rev   Date        Author                          Description
%-------------------------------------------------------------------------------
% v2    11DEC13     Ivica Stevanovic, OFCOM         Various bugs corrected
%                                                   Error handling and
%                                                   hyperlink
% v1    19SEP13     Ivica Stevanovic, OFCOM         Initial version
%
% MATLAB Version 7.12.0.635 (R2011a) used in development of this code


function varargout = ITUP1546(varargin)
% ITUP1546 MATLAB code for ITUP1546.fig
%      ITUP1546, by itself, creates a new ITUP1546 or raises the existing
%      singleton*.
%
%      H = ITUP1546 returns the handle to a new ITUP1546 or the handle to
%      the existing singleton*.
%
%      ITUP1546('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ITUP1546.M with the given input arguments.
%
%      ITUP1546('Property','Value',...) creates a new ITUP1546 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ITUP1546_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ITUP1546_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ITUP1546

% Last Modified by GUIDE v2.5 11-Dec-2013 13:02:14

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ITUP1546_OpeningFcn, ...
                   'gui_OutputFcn',  @ITUP1546_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
%


% --- Executes just before ITUP1546 is made visible.
function ITUP1546_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ITUP1546 (see VARARGIN)

% Choose default command line output for ITUP1546
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ITUP1546 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ITUP1546_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function f_Callback(hObject, eventdata, handles)
% hObject    handle to f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of f as text
%        str2double(get(hObject,'String')) returns contents of f as a double
f=str2double(get(hObject,'String'));
if (isnan(f))
    h = warndlg('Frequency must be between the following limits [30 MHz, 3000 MHz]');
elseif (f<30 || f > 3000)
    h = warndlg('Frequency must be between the following limits [30 MHz, 3000 MHz]');
end

% --- Executes during object creation, after setting all properties.
function f_CreateFcn(hObject, eventdata, handles)
% hObject    handle to f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function t_Callback(hObject, eventdata, handles)
% hObject    handle to t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of t as text
%        str2double(get(hObject,'String')) returns contents of t as a double
f=str2double(get(hObject,'String'));
if (isnan(f))
    h = warndlg('Time percentage must be within the following limits [1%, 50%]');
elseif (f<1|| f > 50)
    h = warndlg('Time percentage must be within the following limits [1%, 50%]');
end


% --- Executes during object creation, after setting all properties.
function t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function q_Callback(hObject, eventdata, handles)
% hObject    handle to q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of q as text
%        str2double(get(hObject,'String')) returns contents of q as a double

in=str2double(get(hObject,'String'));
if (~isnan(in))
if (in<1|| in > 99)
    h = warndlg({'Location variability must be within the following limits [1%, 99%]';...
                 'Default value: 50%'});
    set(hObject,'String','50');
end
else
   h = warndlg({'Location variability must be within the following limits [1%, 99%]';...
                 'Default value: 50%'});
    set(hObject,'String','50');
 
end



% --- Executes during object creation, after setting all properties.
function q_CreateFcn(hObject, eventdata, handles)
% hObject    handle to q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function heff_Callback(hObject, eventdata, handles)
% hObject    handle to heff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of heff as text
%        str2double(get(hObject,'String')) returns contents of heff as a double


% --- Executes during object creation, after setting all properties.
function heff_CreateFcn(hObject, eventdata, handles)
% hObject    handle to heff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ha_Callback(hObject, eventdata, handles)
% hObject    handle to ha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ha as text
%        str2double(get(hObject,'String')) returns contents of ha as a double


% --- Executes during object creation, after setting all properties.
function ha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function hb_Callback(hObject, eventdata, handles)
% hObject    handle to hb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of hb as text
%        str2double(get(hObject,'String')) returns contents of hb as a double


% --- Executes during object creation, after setting all properties.
function hb_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function h2_Callback(hObject, eventdata, handles)
% hObject    handle to h2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of h2 as text
%        str2double(get(hObject,'String')) returns contents of h2 as a double


% --- Executes during object creation, after setting all properties.
function h2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to h2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function R1_Callback(hObject, eventdata, handles)
% hObject    handle to R1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of R1 as text
%        str2double(get(hObject,'String')) returns contents of R1 as a double


% --- Executes during object creation, after setting all properties.
function R1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to R1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function R2_Callback(hObject, eventdata, handles)
% hObject    handle to R2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of R2 as text
%        str2double(get(hObject,'String')) returns contents of R2 as a double


% --- Executes during object creation, after setting all properties.
function R2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to R2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in area.
function area_Callback(hObject, eventdata, handles)
% hObject    handle to area (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns area contents as cell array
%        contents{get(hObject,'Value')} returns selected item from area
% area can be 
% 1 - Rural,    h2=R2=10m
% 2 - Suburban, h2=R2=10m
% 3 - Urban,    h2=R2=20m
% 4 - Dense Urban, h2=R2=30m
% 5 - Adjacent to Sea, h2=R2=10;
% set h2 and R2 fields to their default values when user picks one of the
% area types

contents=cellstr(get(handles.area,'String'));
area=contents{get(handles.area,'Value')};
if ( regexp(area,'Rural,')  )
    handles.data.area='Rural';
    handles.data.R2=10; 
    handles.data.h2=10; 
elseif (regexp(area,'Suburban,') )
    handles.data.area='Suburban';
    handles.data.R2=10;
    handles.data.h2=10;
elseif (regexp(area,'Dense Urban,') )
    handles.data.area='Dense Urban';
    handles.data.R2=30;
    handles.data.h2=30;
elseif (regexp(area,'Urban,') )
    handles.data.area='Urban';
    handles.data.R2=20;
    handles.data.h2=20;
elseif (regexp(area,'Adjacent to Sea,') )
    handles.data.area='Sea';
    handles.data.R2=10;
    handles.data.h2=10;
else 
    return;
end

set(handles.R2,'string',num2str(handles.data.R2));
set(handles.h2,'string',num2str(handles.data.h2));


% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function area_CreateFcn(hObject, eventdata, handles)
% hObject    handle to area (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function htter_Callback(hObject, eventdata, handles)
% hObject    handle to htter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of htter as text
%        str2double(get(hObject,'String')) returns contents of htter as a double


% --- Executes during object creation, after setting all properties.
function htter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to htter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function hrter_Callback(hObject, eventdata, handles)
% hObject    handle to hrter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of hrter as text
%        str2double(get(hObject,'String')) returns contents of hrter as a double


% --- Executes during object creation, after setting all properties.
function hrter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hrter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function tca_Callback(hObject, eventdata, handles)
% hObject    handle to tca (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tca as text
%        str2double(get(hObject,'String')) returns contents of tca as a double


% --- Executes during object creation, after setting all properties.
function tca_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tca (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function eff1_Callback(hObject, eventdata, handles)
% hObject    handle to eff1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of eff1 as text
%        str2double(get(hObject,'String')) returns contents of eff1 as a double


% --- Executes during object creation, after setting all properties.
function eff1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to eff1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function eff2_Callback(hObject, eventdata, handles)
% hObject    handle to eff2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of eff2 as text
%        str2double(get(hObject,'String')) returns contents of eff2 as a double


% --- Executes during object creation, after setting all properties.
function eff2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to eff2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function d1_Callback(hObject, eventdata, handles)
% hObject    handle to d1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of d1 as text
%        str2double(get(hObject,'String')) returns contents of d1 as a double


% --- Executes during object creation, after setting all properties.
function d1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to d1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function d2_Callback(hObject, eventdata, handles)
% hObject    handle to d2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of d2 as text
%        str2double(get(hObject,'String')) returns contents of d2 as a double


% --- Executes during object creation, after setting all properties.
function d2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to d2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function d3_Callback(hObject, eventdata, handles)
% hObject    handle to d3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of d3 as text
%        str2double(get(hObject,'String')) returns contents of d3 as a double


% --- Executes during object creation, after setting all properties.
function d3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to d3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function d4_Callback(hObject, eventdata, handles)
% hObject    handle to d4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of d4 as text
%        str2double(get(hObject,'String')) returns contents of d4 as a double


% --- Executes during object creation, after setting all properties.
function d4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to d4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in path1.
function path1_Callback(hObject, eventdata, handles)
% hObject    handle to path1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns path1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from path1


% --- Executes during object creation, after setting all properties.
function path1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to path1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in path2.
function path2_Callback(hObject, eventdata, handles)
% hObject    handle to path2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns path2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from path2


% --- Executes during object creation, after setting all properties.
function path2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to path2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in path3.
function path3_Callback(hObject, eventdata, handles)
% hObject    handle to path3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns path3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from path3


% --- Executes during object creation, after setting all properties.
function path3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to path3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in path4.
function path4_Callback(hObject, eventdata, handles)
% hObject    handle to path4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns path4 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from path4


% --- Executes during object creation, after setting all properties.
function path4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to path4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in dependence.
function dependence_Callback(hObject, eventdata, handles)
% hObject    handle to dependence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns dependence contents as cell array
%        contents{get(hObject,'Value')} returns selected item from dependence


% --- Executes during object creation, after setting all properties.
function dependence_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dependence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dependence1_Callback(hObject, eventdata, handles)
% hObject    handle to dependence1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dependence1 as text
%        str2double(get(hObject,'String')) returns contents of dependence1 as a double


% --- Executes during object creation, after setting all properties.
function dependence1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dependence1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dependence2_Callback(hObject, eventdata, handles)
% hObject    handle to dependence2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dependence2 as text
%        str2double(get(hObject,'String')) returns contents of dependence2 as a double


% --- Executes during object creation, after setting all properties.
function dependence2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dependence2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function dependencesteps_Callback(hObject, eventdata, handles)
% hObject    handle to dependencesteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dependencesteps as text
%        str2double(get(hObject,'String')) returns contents of dependencesteps as a double


% --- Executes during object creation, after setting all properties.
function dependencesteps_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dependencesteps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in log.
function log_Callback(hObject, eventdata, handles)
% hObject    handle to log (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of log


% --- Executes on button press in ComputeSignalStrength.
function ComputeSignalStrength_Callback(hObject, eventdata, handles)
% hObject    handle to ComputeSignalStrength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit26_Callback(hObject, eventdata, handles)
% hObject    handle to edit26 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit26 as text
%        str2double(get(hObject,'String')) returns contents of edit26 as a double


% --- Executes during object creation, after setting all properties.
function edit26_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit26 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit27_Callback(hObject, eventdata, handles)
% hObject    handle to edit27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit27 as text
%        str2double(get(hObject,'String')) returns contents of edit27 as a double


% --- Executes during object creation, after setting all properties.
function edit27_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit27 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit28_Callback(hObject, eventdata, handles)
% hObject    handle to edit28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit28 as text
%        str2double(get(hObject,'String')) returns contents of edit28 as a double


% --- Executes during object creation, after setting all properties.
function edit28_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit29_Callback(hObject, eventdata, handles)
% hObject    handle to edit29 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit29 as text
%        str2double(get(hObject,'String')) returns contents of edit29 as a double


% --- Executes during object creation, after setting all properties.
function edit29_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit29 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit30_Callback(hObject, eventdata, handles)
% hObject    handle to edit30 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit30 as text
%        str2double(get(hObject,'String')) returns contents of edit30 as a double


% --- Executes during object creation, after setting all properties.
function edit30_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit30 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit31_Callback(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit31 as text
%        str2double(get(hObject,'String')) returns contents of edit31 as a double


% --- Executes during object creation, after setting all properties.
function edit31_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit32_Callback(hObject, eventdata, handles)
% hObject    handle to edit32 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit32 as text
%        str2double(get(hObject,'String')) returns contents of edit32 as a double


% --- Executes during object creation, after setting all properties.
function edit32_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit32 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Eout_Callback(hObject, eventdata, handles)
% hObject    handle to Eout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Eout as text
%        str2double(get(hObject,'String')) returns contents of Eout as a double


% --- Executes during object creation, after setting all properties.
function Eout_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Eout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Lout_Callback(hObject, eventdata, handles)
% hObject    handle to Lout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Lout as text
%        str2double(get(hObject,'String')) returns contents of Lout as a double


% --- Executes during object creation, after setting all properties.
function Lout_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Lout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in compute.
function compute_Callback(hObject, eventdata, handles)
% hObject    handle to compute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Retrieve the input values

[hObject, handles] = retrieveInputdata(hObject,eventdata,handles);

if(checkInput(hObject, eventdata, handles))

% call the function and compute the values of field strength

E = P1546FieldStrMixed(...
    handles.data.f, ...
    handles.data.t,...
    handles.data.heff,...
    handles.data.h2,...
    handles.data.R2,...
    handles.data.area,...
    handles.data.d_v,...
    handles.data.path_c,...
    handles.data.q,...
    handles.data.PTx,...
    handles.data.ha,...
    handles.data.hb,...
    handles.data.R1,...
    handles.data.tca,...
    handles.data.htter,...
    handles.data.hrter,...
    handles.data.eff1,...
    handles.data.eff2...
   );

% Compute the equivalent basic transmission loss for the path

Lb = 139.3 - ( E-10*log10(handles.data.PTx)) + 20*log10(handles.data.f);
% set the value to the field Eout
set(handles.Eout, 'String', num2str(E));

% set the value to the field Lout
set(handles.Lout, 'String', num2str(Lb));

% Update handles structure
guidata(hObject, handles);
end







% --- Executes on button press in Plot.
function Plot_Callback(hObject, eventdata, handles)
% hObject    handle to Plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First retreive all input data from all the text fields
[hObject, handles] = retrieveInputdata(hObject, eventdata, handles);

if (checkInput(hObject, eventdata, handles))

if handles.data.dependence==1
    % distance d, only one path type
    
    if length(handles.data.d_v)>1
        warndlg('Only one path type permitted in this calculation');
        return
    end
    
    d1 = str2double(get(handles.dependence1,'String'));
    if ~isnan(d1)
        if (d1<0 || d1>1000)
            warndlg('Start distance out of permitted band (0 1000] km.'); 
            return
        end
        if (d1<1)
            if (isempty(handles.data.ha))
               warndlg('For distances less than 1 km, at least the optional parameter ''ha'' needs to be defined.');
               return
            end
        end
    else
        warndlg('Start distance not defined.');
        return
    end
        
    d2 = str2double(get(handles.dependence2,'String'));
    if ~isnan(d2)
        if (d2<0 || d2>1000)
            warndlg('Stop distance out of permitted band (0 1000] km.');
            return
        end
        
        if (d2<=d1)
            warndlg('Stop distance needs to be larger than start distance.');
            return
        end
    else
        warndlg('Stop distance not defined.');
        return
    end 
    NN=str2double(get(handles.dependencesteps,'String'));
    if ~isnan(NN)
        if (NN<1)
            warndlg('Number of steps should not be less than 1.')
            return
        end
    else
        warndlg('Number of steps not defined.')
        return
    end
    
    log=get(handles.log,'Value') ;
    dd=[];
    EE=[];
    if(log)
        dd=logspace(log10(d1),log10(d2),NN);
        if dd(1) < 0
            dd(1)=0.001;
        end
        if dd(end)>1000
            dd(end)=1000;
        end
    else
        dd=linspace(d1,d2,NN);
    end
    
    for ii=1:length(dd)
        
        EE(ii)= P1546FieldStrMixed(...
            handles.data.f, ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            dd(ii),...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
    

    end

    ax=handles.axes1;
    cla;
    plot(ax,dd,EE,'LineWidth',1,'Color','k');
    xlabel('Distance (km)');
    ylabel('Signal strength (dB(uV/m))');
    grid on
    if (log)
        set(ax,'XScale','log','XMinorGrid', 'off');
    else
        set(ax,'XScale','lin');
    end
    
    % Graphically present the result for the set of input parameters
    
    Es =  P1546FieldStrMixed(...
            handles.data.f, ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
     
            hold on
            h = plot(ax,handles.data.d_v(1), Es, 'r>');
            set(h,'MarkerSize',10);
            
            Lb = 139.3 - ( Es-10*log10(handles.data.PTx)) + 20*log10(handles.data.f);
            % set the value to the field Eout
            set(handles.Eout, 'String', num2str(Es));
            
            % set the value to the field Lout
            set(handles.Lout, 'String', num2str(Lb));
            
            % Update handles structure
            guidata(hObject, handles);
 

                
elseif handles.data.dependence==2
    % frequency f
    
    f1 = str2double(get(handles.dependence1,'String'));
    if ~isnan(f1)
        if (f1<30 || f1>3000)
            warndlg('Start frequency out of permitted band [30 3000] MHz.'); 
            return
        end
    else
        warndlg('Start frequency not defined.');
        return
    end
        
    f2 = str2double(get(handles.dependence2,'String'));
    if ~isnan(f2)
        if (f2<30 || f2>3000)
            warndlg('Stop frequency out of permitted band [30 3000] MHz.');
            return
        end
        
        if (f2<=f1)
            warndlg('Stop frequency needs to be larger than start frequency.');
            return
        end
    else
        warndlg('Stop frequency not defined.');
        return
    end 
    NN=str2double(get(handles.dependencesteps,'String'));
    if ~isnan(NN)
        if (NN<1)
            warndlg('Number of steps should not be less than 1.')
            return
        end
    else
        warndlg('Number of steps not defined.')
        return
    end
    
    log=get(handles.log,'Value') ;
    ff=[];
    EE=[];
    if(log)
        ff=logspace(log10(f1),log10(f2),NN);
        if ff(1) < 30
            ff(1)=30;
        end
        if ff(end)>3000
            ff(end)=3000;
        end
    else
        ff=linspace(f1,f2,NN);
    end
    
    for ii=1:length(ff)
        
        EE(ii)=  P1546FieldStrMixed(...
            ff(ii), ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
           

    end

    ax=handles.axes1;
    cla;
    plot(ax,ff,EE,'LineWidth',1,'Color','k');
    xlabel('Frequency (MHz)');
    ylabel('Signal strength (dB(uV/m))');
    grid on
    if (log)
        set(ax,'XScale','log','XMinorGrid', 'off');
    else
        set(ax,'XScale','lin');
    end
    
    % Graphically present the result for the set of input parameters
    
    Es = P1546FieldStrMixed(...
            handles.data.f, ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
     
            hold on
            h = plot(ax,handles.data.f, Es, 'r>');
            set(h,'MarkerSize',10);
            Lb = 139.3 - ( Es-10*log10(handles.data.PTx)) + 20*log10(handles.data.f);
            % set the value to the field Eout
            set(handles.Eout, 'String', num2str(Es));
            
            % set the value to the field Lout
            set(handles.Lout, 'String', num2str(Lb));
            
            % Update handles structure
            guidata(hObject, handles);

    
elseif handles.data.dependence==3
    % percentage time t
    
 
    d1 = str2double(get(handles.dependence1,'String'));
    dinf=1;
    dsup=50;
    if ~isnan(d1)
        if (d1<dinf || d1>dsup)
            warndlg('Start time out of permitted band [1 50] %.'); 
            return
        end
    else
        error('Start time not defined.');
        
    end
        
    d2 = str2double(get(handles.dependence2,'String'));
    if ~isnan(d2)
        if (d2<dinf || d2>dsup)
           warndlg('Stop time out of permitted band [1 50] %.');
           return
        end
        
        if (d2<=d1)
            warndlg('Stop time needs to be larger than start time.');
            return
        end
    else
       warndlg('Stop time not defined.');
       return
    end 
    NN=str2double(get(handles.dependencesteps,'String'));
    if ~isnan(NN)
        if (NN<1)
            warndlg('Number of steps should not be less than 1.')
            return
        end
    else
        warndlg('Number of steps not defined.')
        return
    end
    
    log=get(handles.log,'Value') ;
    dd=[];
    EE=[];
    if(log)
        dd=logspace(log10(d1),log10(d2),NN);
        if dd(1) < dinf
            dd(1)=dinf;
        end
        if dd(end)>dsup
            dd(end)=dsup;
        end
    else
        dd=linspace(d1,d2,NN);
    end
    
    for ii=1:length(dd)
        
        EE(ii)=  P1546FieldStrMixed(...
            handles.data.f, ...
            dd(ii),...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
           

    end

    ax=handles.axes1;
    cla;
    plot(ax,dd,EE,'LineWidth',1,'Color','k');
    xlabel('Percentage time (%)');
    ylabel('Signal strength (dB(uV/m))');
    grid on
    if (log)
        set(ax,'XScale','log','XMinorGrid', 'off');
    else
        set(ax,'XScale','lin');
    end
    
    % Graphically present the result for the set of input parameters
    
    Es =  P1546FieldStrMixed(...
            handles.data.f, ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
     
            hold on
            h = plot(ax,handles.data.t, Es, 'r>');
            set(h,'MarkerSize',10);
    
            Lb = 139.3 - ( Es-10*log10(handles.data.PTx)) + 20*log10(handles.data.f);
            % set the value to the field Eout
            set(handles.Eout, 'String', num2str(Es));

            % set the value to the field Lout
            set(handles.Lout, 'String', num2str(Lb));

            % Update handles structure
            guidata(hObject, handles);

    
elseif handles.data.dependence==4
    % percentage location q
    
    
    d1 = str2double(get(handles.dependence1,'String'));
    dinf=1;
    dsup=99;
    if ~isnan(d1)
        if (d1<dinf || d1>dsup)
            warndlg('Start location variability out of permitted band [1 99] %.'); 
            return
        end
    else
        warndlg('Start location variability not defined.');
        return
        
    end
        
    d2 = str2double(get(handles.dependence2,'String'));
    if ~isnan(d2)
        if (d2<dinf || d2>dsup)
            warndlg('Stop location variability out of permitted band [1 99] %.');
            return
        end
        
        if (d2<=d1)
            warndlg('Stop location variability needs to be larger than start location variability.');
            return
        end
    else
        warndlg('Stop locatino variability not defined.');
        return
    end 
    NN=str2double(get(handles.dependencesteps,'String'));
    if ~isnan(NN)
        if (NN<1)
            warndlg('Number of steps should not be less than 1.')
            return
        end
    else
        warndlg('Number of steps not defined.')
        return
    end
    
    log=get(handles.log,'Value') ;
    dd=[];
    EE=[];
    if(log)
        dd=logspace(log10(d1),log10(d2),NN);
        if dd(1) < dinf
            dd(1)=dinf;
        end
        if dd(end)>dsup
            dd(end)=dsup;
        end
    else
        dd=linspace(d1,d2,NN);
    end
    
    for ii=1:length(dd)
        
        EE(ii)=  P1546FieldStrMixed(...
            handles.data.f, ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            dd(ii),...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
           

    end

    ax=handles.axes1;
    cla;
    plot(ax,dd,EE,'LineWidth',1,'Color','k');
    xlabel('Location variability (%)');
    ylabel('Signal strength (dB(uV/m))');
    grid on
    if (log)
        set(ax,'XScale','log','XMinorGrid', 'off');
    else
        set(ax,'XScale','lin');
    end
    
    % Graphically present the result for the set of input parameters
    
    Es =  P1546FieldStrMixed(...
            handles.data.f, ...
            handles.data.t,...
            handles.data.heff,...
            handles.data.h2,...
            handles.data.R2,...
            handles.data.area,...
            handles.data.d_v,...
            handles.data.path_c,...
            handles.data.q,...
            handles.data.PTx,...
            handles.data.ha,...
            handles.data.hb,...
            handles.data.R1,...
            handles.data.tca,...
            handles.data.htter,...
            handles.data.hrter,...
            handles.data.eff1,...
            handles.data.eff2...
            );
        
     
            hold on
            h = plot(ax,handles.data.q, Es, 'r>');
            set(h,'MarkerSize',10);
            
            Lb = 139.3 - ( Es-10*log10(handles.data.PTx)) + 20*log10(handles.data.f);
            % set the value to the field Eout
            set(handles.Eout, 'String', num2str(Es));

            % set the value to the field Lout
            set(handles.Lout, 'String', num2str(Lb));

            % Update handles structure
            guidata(hObject, handles);


else
    warndlg('Please choose the signal strength function.')
    return
end
end



% -- Retrieves input data from all the text fields
function [hObject1, handles1] = retrieveInputdata(hObject,eventdata,handles)

handles.data.f = str2double(get(handles.f,'String'));
if isnan(handles.data.f)
    handles.data.f=[];
end
handles.data.t = str2double(get(handles.t,'String'));
if isnan(handles.data.t)
    handles.data.t=[];
end
handles.data.q = str2double(get(handles.q,'String'));
if isnan(handles.data.q)
    handles.data.q=50;
end
handles.data.heff = str2double(get(handles.heff,'String'));
if isnan(handles.data.heff)
    handles.data.heff=[];
end

contents=cellstr(get(handles.path1,'String'));
path1=contents{get(handles.path1,'Value')};
handles.data.NN=0;
handles.data.d_v=[];
handles.data.path_c={};
if (~strcmp(path1,'Segment 1'))
    handles.data.d_v(1) = str2double(get(handles.d1,'String'));
    handles.data.path_c{1}=path1;
    handles.data.NN = handles.data.NN+1;
end

contents=cellstr(get(handles.path2,'String'));
path2=contents{get(handles.path2,'Value')};
if (~strcmp(path2,'Segment 2'))
    handles.data.d_v(2) = str2double(get(handles.d2,'String'));
    handles.data.path_c{2}=path2;
    handles.data.NN = handles.data.NN+1;
else
    set(handles.d2,'String','');
end

contents=cellstr(get(handles.path3,'String'));
path3=contents{get(handles.path3,'Value')};
if (~strcmp(path3,'Segment 3'))
    handles.data.d_v(3) = str2double(get(handles.d3,'String'));
    handles.data.path_c{3}=path3;
    handles.data.NN = handles.data.NN+1;
else
    set(handles.d3,'String','');
end

contents=cellstr(get(handles.path4,'String'));
path4=contents{get(handles.path4,'Value')};
if (~strcmp(path4,'Segment 4'))
    handles.data.d_v(4) = str2double(get(handles.d4,'String'));
    handles.data.path_c{4}=path4;
    handles.data.NN = handles.data.NN+1;
else
    set(handles.d4,'String','');
end



% Retrieve optional input parameters
handles.data.ha = str2double(get(handles.ha,'String'));
if isnan(handles.data.ha)
    handles.data.ha=[];
end
handles.data.hb = str2double(get(handles.hb,'String'));
if isnan(handles.data.hb)
    handles.data.hb=[];
end
handles.data.h2 = str2double(get(handles.h2,'String'));
if isnan(handles.data.h2)
    handles.data.h2=[];
end
handles.data.R1 = str2double(get(handles.R1,'String'));
if isnan(handles.data.R1)
    handles.data.R1=[];
end
handles.data.R2 = str2double(get(handles.R2,'String'));
if isnan(handles.data.R2)
    handles.data.R2=[];
end
handles.data.htter = str2double(get(handles.htter,'String'));
if isnan(handles.data.htter)
    handles.data.htter=[];
end
handles.data.hrter = str2double(get(handles.hrter,'String'));
if isnan(handles.data.hrter)
    handles.data.hrter=[];
end
handles.data.tca = str2double(get(handles.tca,'String'));
if isnan(handles.data.tca)
    handles.data.tca=[];
end
handles.data.eff1 = str2double(get(handles.eff1,'String'));
if isnan(handles.data.eff1)
    handles.data.eff1=[];
end
handles.data.eff2 = str2double(get(handles.eff2,'String'));
if isnan(handles.data.eff2)
    handles.data.eff2=[];
end

handles.data.area=[];

contents=cellstr(get(handles.area,'String'));
area=contents{get(handles.area,'Value')};
if ( regexp(area,'Rural,')  )
    handles.data.area='Rural';
    %handles.data.R2=10; 
    %handles.data.h2=10; 
elseif (regexp(area,'Suburban,') )
    handles.data.area='Suburban';
    %handles.data.R2=10;
    %handles.data.h2=10;
elseif (regexp(area,'Dense Urban,') )
    handles.data.area='Dense Urban';
    %handles.data.R2=30;
    %handles.data.h2=30;
elseif (regexp(area,'Urban,') )
    handles.data.area='Urban';
    %handles.data.R2=20;
    %handles.data.h2=20;
elseif (regexp(area,'Adjacent to Sea,') )
    handles.data.area='Sea';
    %handles.data.R2=10;
    %handles.data.h2=10;

end


handles.data.dep1=str2double(get(handles.dependence1,'String'));
handles.data.dep2=str2double(get(handles.dependence2,'String'));
handles.data.depN=str2double(get(handles.dependencesteps,'String'));

contents=cellstr(get(handles.dependence,'String'));
dependence=contents{get(handles.dependence,'Value')};
handles.data.dependence=find(strcmp(contents,dependence))-1;

handles.data.PTx = str2double(get(handles.PTx,'String'));
if isnan(handles.data.PTx)
    handles.data.eff2.PTx = 1;
end


% Update handles structure
guidata(hObject, handles);


handles1=handles;
hObject1=hObject;



function edit42_Callback(hObject, eventdata, handles)
% hObject    handle to h2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of h2 as text
%        str2double(get(hObject,'String')) returns contents of h2 as a double


% --- Executes during object creation, after setting all properties.
function edit42_CreateFcn(hObject, eventdata, handles)
% hObject    handle to h2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function PTx_Callback(hObject, eventdata, handles)
% hObject    handle to PTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PTx as text
%        str2double(get(hObject,'String')) returns contents of PTx as a double
in=str2double(get(hObject,'String'));
if (~isnan(in))
if (in<=0)
    h = warndlg({'Transmission power must be positive';...
                 'Default value: 1 kW'});
    set(hObject,'String','1');
end
else
       h = warndlg({'Transmission power must be positive';...
                 'Default value: 1 kW'});
          set(hObject,'String','1');       
end

% --- Executes during object creation, after setting all properties.
function PTx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% -- Verify all the data is defined before you start computation
function alldefined=checkInput(hObject, eventdata, handles)

alldefined=true;

in=handles.data.PTx;
if (~isnan(in))
    if(in<=0)
    warndlg({'Transmission power P must be defined and positive'});
    alldefined=false;
    return
    end
else
    warndlg({'Transmission power P must be defined and positive'});
    alldefined=false;
    return
end

in=handles.data.f;
if (~isnan(in))
    if(in<30 || in> 3000)
    warndlg({'Frequency f must be defined within 30 MHz - 3000 MHz'});
    alldefined=false;
    return
    end
else
    warndlg({'Frequency f must be defined within 30 MHz - 3000 MHz'});
    alldefined=false;
    return
end

in=handles.data.t;
errormsg='Time percentage must be defined within 1% - 50%';
if (~isnan(in))
    if(in<1 || in> 50)
    warndlg(errormsg);
    alldefined=false;
    return
    end
else
    warndlg(errormsg);
    alldefined=false;
    return
end
    
in=handles.data.q;
errormsg='Location variability must be defined within 1% - 99%';
if (~isnan(in))
    if(in<1 || in> 99)
    warndlg(errormsg);
    alldefined=false;
    return
    end
else
    warndlg(errormsg);
    alldefined=false;
    return
end

in=handles.data.heff;
errormsg='Effective height of the transmitter antenna not defined';
if (isnan(in))
    warndlg(errormsg);
    alldefined=false;
    return
else
    if (in<=0)
        warndlg('Effective height must be a positive number');
        alldefined=false;
        return
    end
    if(isempty(in))
        warndlg('Effective height of the transmitter antenna not defined');
        alldefined=false;
        return
    end
end

in=handles.data.area;
errormsg='Receiver area type must be defined';
if (isempty(in))
    warndlg(errormsg);
    alldefined=false;
    return
end


if (handles.data.NN == 0)
        warndlg({'There must be at least one path type defined.'});
        alldefined=false;
        return
end

if isempty(handles.data.d_v)
        warndlg({'There must be at least one path length defined.'});
        alldefined=false;
        return
end

if isempty(handles.data.path_c)
        warndlg({'There must be at least one path type defined.'});
        alldefined=false;
        return
end 


for ii=1: length(handles.data.path_c) 
    if(isnan(handles.data.d_v(ii)))
        warndlg({'Path type and path distances are not properly defined.'});
        alldefined=false;
        return
    end
    if(handles.data.d_v(ii)<=0)
       warndlg({'Path distance must be a positive number.'});
        alldefined=false;
        return
    end   
end

if (sum(handles.data.d_v < 1))
    if (isempty(handles.data.ha))
        warndlg('For total distance less than 1 km, at least the optional parameter ''ha'' needs to be defined.');
        alldefined=false;
        return
    end
end


% --- Executes on button press in web.
function web_Callback(hObject, eventdata, handles)
% hObject    handle to web (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

web('http://www.google.ch/url?sa=t&rct=j&q=&esrc=s&frm=1&source=web&cd=1&cad=rja&ved=0CCwQFjAA&url=http%3A%2F%2Fwww.itu.int%2Frec%2FR-REC-P.1546%2Fen&ei=plOoUqWtDIWyywPgxYCQCw&usg=AFQjCNEDb6EgwAaOoXcaLog-FFafsQTtPg&sig2=6h2djUUxdhpsRj9qwoXQqg&bvm=bv.57799294,d.bGQ', '-browser');
